<?php

namespace CustomerManagement\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DownloadToPanelOutput StructType
 * @subpackage Structs
 */
class DownloadToPanelOutput extends AbstractStructBase
{
    /**
     * The Success
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Success;
    /**
     * The ErrorMessage
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ErrorMessage;
    /**
     * The ValidationErrors
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \CustomerManagement\ArrayType\ArrayOfDownloadValidationError
     */
    public $ValidationErrors;
    /**
     * Constructor method for DownloadToPanelOutput
     * @uses DownloadToPanelOutput::setSuccess()
     * @uses DownloadToPanelOutput::setErrorMessage()
     * @uses DownloadToPanelOutput::setValidationErrors()
     * @param bool $success
     * @param string $errorMessage
     * @param \CustomerManagement\ArrayType\ArrayOfDownloadValidationError $validationErrors
     */
    public function __construct($success = null, $errorMessage = null, \CustomerManagement\ArrayType\ArrayOfDownloadValidationError $validationErrors = null)
    {
        $this
            ->setSuccess($success)
            ->setErrorMessage($errorMessage)
            ->setValidationErrors($validationErrors);
    }
    /**
     * Get Success value
     * @return bool
     */
    public function getSuccess()
    {
        return $this->Success;
    }
    /**
     * Set Success value
     * @param bool $success
     * @return \CustomerManagement\StructType\DownloadToPanelOutput
     */
    public function setSuccess($success = null)
    {
        // validation for constraint: boolean
        if (!is_null($success) && !is_bool($success)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($success, true), gettype($success)), __LINE__);
        }
        $this->Success = $success;
        return $this;
    }
    /**
     * Get ErrorMessage value
     * @return string|null
     */
    public function getErrorMessage()
    {
        return $this->ErrorMessage;
    }
    /**
     * Set ErrorMessage value
     * @param string $errorMessage
     * @return \CustomerManagement\StructType\DownloadToPanelOutput
     */
    public function setErrorMessage($errorMessage = null)
    {
        // validation for constraint: string
        if (!is_null($errorMessage) && !is_string($errorMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errorMessage, true), gettype($errorMessage)), __LINE__);
        }
        $this->ErrorMessage = $errorMessage;
        return $this;
    }
    /**
     * Get ValidationErrors value
     * @return \CustomerManagement\ArrayType\ArrayOfDownloadValidationError|null
     */
    public function getValidationErrors()
    {
        return $this->ValidationErrors;
    }
    /**
     * Set ValidationErrors value
     * @param \CustomerManagement\ArrayType\ArrayOfDownloadValidationError $validationErrors
     * @return \CustomerManagement\StructType\DownloadToPanelOutput
     */
    public function setValidationErrors(\CustomerManagement\ArrayType\ArrayOfDownloadValidationError $validationErrors = null)
    {
        $this->ValidationErrors = $validationErrors;
        return $this;
    }
}
